=== modified file 'src/com/goldencode/p2j/convert/TransformDriver.java'
--- old/src/com/goldencode/p2j/convert/TransformDriver.java	2022-05-16 12:34:34 +0000
+++ new/src/com/goldencode/p2j/convert/TransformDriver.java	2022-05-20 12:10:05 +0000
@@ -36,6 +36,8 @@
 **                  resource (like a file or namespace) is being processed.  Only front phase is supported at 
 **                  this time.
 **     CA  20220516 Made JobDefinition protected.
+**     GES 20210520 Sort interfaces into the BFS class hierachy so that all overridden methods will be
+**                  converted in the correct order (the parent version first). 
 */
 
 /*
@@ -179,6 +181,9 @@
    /** Full details of this run. */
    protected JobDefinition job = null;
    
+   /** Base class for all OO classes. */
+   private static final String ROOT_CLASS = "Progress.Lang.Object".toLowerCase();
+   
    /**
     * Creates an instance with a specific configuration.
     *
@@ -1625,6 +1630,143 @@
    }
    
    /**
+    * Read the class hierarchy from the AST associated with the given filename and store the state in
+    * the given maps.
+    *  
+    * @param    mgr
+    *           AST manager.
+    * @param    cls2file
+    *           Map of qualified class names to file names.
+    * @param    clsHierarchy
+    *           Map of qualified class names to a set of subclasses.
+    * @param    file
+    *           The file name to process.
+    */
+   private static void processOODefinition(AstManager               mgr,
+                                           Map<String, String>      cls2file,
+                                           Map<String, Set<String>> clsHierarchy,
+                                           String                   file)
+   {
+      // temporarily load this AST and get:
+      // - the qualified class name
+      // - the super class (single inherits for a class) or super interfaces (multiple-inherits for 
+      //   interface)
+      // - all implemented interfaces (which we treat the same as a superclass) for a class
+      
+      Aast ast    = mgr.loadTree(file);
+      Aast def    = ast.getImmediateChild(ProgressParserTokenTypes.CLASS_DEF, null);
+      Aast header = null;
+      
+      if (def == null)
+      {
+         def = ast.getImmediateChild(ProgressParserTokenTypes.INTERFACE_DEF, null);
+         
+         if (def == null)
+         {
+            // must be an enum, nothing to do
+            return;
+         }
+         else
+         {
+            header = def.getImmediateChild(ProgressParserTokenTypes.KW_INTERFAC, null);
+         }
+      }
+      else
+      {
+         header = def.getImmediateChild(ProgressParserTokenTypes.KW_CLASS, null);
+      }
+      
+      List<String> supers = new LinkedList<String>();
+      
+      if (header.downPath("KW_INHERITS/CLASS_NAME"))
+      {
+         Aast ref = header.getImmediateChild(ProgressParserTokenTypes.KW_INHERITS, null);
+         
+         processClassNames(ref, clsHierarchy, supers);
+      }
+
+      if (header.downPath("KW_IMPLEMTS/CLASS_NAME"))
+      {
+         Aast ref2 = header.getImmediateChild(ProgressParserTokenTypes.KW_IMPLEMTS, null);
+         
+         processClassNames(ref2, clsHierarchy, supers);
+      }
+
+      if (supers.isEmpty())
+      {
+         supers.add(ROOT_CLASS);
+      }
+      
+      Aast   sym   = header.getImmediateChild(ProgressParserTokenTypes.SYMBOL, null);
+      String qname = sym.getText().toLowerCase();
+      
+      cls2file.put(qname, file);
+
+      // link the qname into the set for every super class/super interface/implemented interface
+      for (String superClass : supers)
+      {
+         Set<String> subClasses = clsHierarchy.get(superClass);
+
+         // create a new set if the superclass hasn't been processed yet
+         if (subClasses == null)
+         {
+            clsHierarchy.put(superClass, subClasses = new TreeSet<>());
+         }
+         
+         // Progress.Lang.Object will recurse endlessly if we try to make it a subclass of itself
+         if (!superClass.toLowerCase().equals(qname))
+         {
+            subClasses.add(qname);
+         }
+      }
+   }
+   
+   /**
+    * Process the given AST node for all {@code CLASS_NAME} child nodes.  For each child node, read
+    * the qualified class name and add it to the given list of super classes.  For built-in classes
+    * link them to the root class even if they are not direct children.
+    * 
+    * @param    ref
+    *           The {@code KW_INHERITS} or {@code KW_IMPLEMTS} node which has one or more class name
+    *           children. 
+    * @param    clsHierarchy
+    *           The map of subclasses for each parent class.
+    * @param    supers
+    *           The list to which to add any inherited super class, inherited interfaces and any
+    *           implemented interfaces.
+    */
+   private static void processClassNames(Aast                     ref,
+                                         Map<String, Set<String>> clsHierarchy,
+                                         List<String>             supers)
+   {
+      Aast child = ref.getImmediateChild(ProgressParserTokenTypes.CLASS_NAME, null);
+      
+      while (child != null)
+      {
+         Boolean builtinCls = (Boolean) child.getAnnotation("builtin-cls");
+         String  superClass = (String) child.getAnnotation("qualified");
+         superClass = superClass.toLowerCase();
+         
+         supers.add(superClass);
+         
+         if (builtinCls != null && builtinCls.booleanValue() && !ROOT_CLASS.equals(superClass))
+         {
+            // for all builtin classes, add them to the 'progress.lang.object' sub-classes
+            Set<String> subClasses = clsHierarchy.get(ROOT_CLASS);
+            
+            if (subClasses == null)
+            {
+               clsHierarchy.put(ROOT_CLASS, subClasses = new TreeSet<>());
+            }
+            
+            subClasses.add(superClass);
+         }
+         
+         child = child.getImmediateChild(ProgressParserTokenTypes.CLASS_NAME, child);
+      }
+   }
+   
+   /**
     * Sort all legacy classes in the specified sources, by computed the class hierarchy and 
     * performing a BFS walk starting from <code>Progress.Lang.Object</code>.  Interfaces are not
     * included in this sort.
@@ -1637,79 +1779,26 @@
     */
    private static List<String> sortLegacyClasses(Set<String> sources)
    {
-      String rootClass = "Progress.Lang.Object".toLowerCase();
-      
       AstManager mgr = AstManager.get();
       
-      Map<String, String> cls2file = new HashMap<>();
+      Map<String, String>      cls2file     = new HashMap<>();
       Map<String, Set<String>> clsHierarchy = new HashMap<>();
       
       for (String file : sources)
       {
          if (file.endsWith(".cls.ast"))
          {
-            // temporarily load this AST and get:
-            // - the qualified class name
-            // - the super class
-            Aast ast = mgr.loadTree(file);
-            Aast clsDef = ast.getImmediateChild(ProgressParserTokenTypes.CLASS_DEF, null);
-            if (clsDef == null)
-            {
-               // must be an interface
-               continue;
-            }
-            
-            String superClass = rootClass;
-            Aast kwClass = clsDef.getImmediateChild(ProgressParserTokenTypes.KW_CLASS, null);
-            
-            if (kwClass.downPath("KW_INHERITS/CLASS_NAME"))
-            {
-               Aast ref = kwClass.getImmediateChild(ProgressParserTokenTypes.KW_INHERITS, null);
-               ref = ref.getImmediateChild(ProgressParserTokenTypes.CLASS_NAME, null);
-               Boolean builtinCls = (Boolean) ref.getAnnotation("builtin-cls");
-               superClass = (String) ref.getAnnotation("qualified");
-               superClass = superClass.toLowerCase();
-               
-               if (builtinCls != null        &&
-                   builtinCls &&
-                   !rootClass.equals(superClass))
-               {
-                  // for all builtin classes, add them to the 'progress.lang.object' sub-classes
-                  Set<String> subClasses = clsHierarchy.get(rootClass);
-                  if (subClasses == null)
-                  {
-                     clsHierarchy.put(rootClass, subClasses = new TreeSet<>());
-                  }
-                  subClasses.add(superClass);
-               }
-            }
-            
-            Aast ref = kwClass.getImmediateChild(ProgressParserTokenTypes.SYMBOL, null);
-            String qname = ref.getText().toLowerCase();
-            
-            cls2file.put(qname, file);
-            
-            Set<String> subClasses = clsHierarchy.get(superClass);
-            if (subClasses == null)
-            {
-               clsHierarchy.put(superClass, subClasses = new TreeSet<>());
-            }
-            
-            // Progress.Lang.Object will recurse endlessly if we try to make it
-            // a subclass of itself
-            if (!superClass.toLowerCase().equals(qname))
-            {
-               subClasses.add(qname);
-            }
+            processOODefinition(mgr, cls2file, clsHierarchy, file);
          }
       }
       
-      List<String> bfs = walkHierarchy(clsHierarchy, rootClass);
-      
+      List<String> bfs   = walkHierarchy(clsHierarchy, ROOT_CLASS);
       List<String> files = new ArrayList<>();
+      
       for (String cls : bfs)
       {
          String file = cls2file.get(cls);
+         
          if (file != null)
          {
             // may be null in case of skeleton classes
@@ -1735,6 +1824,7 @@
       parent = parent.toLowerCase();
 
       Set<String> subClasses = hierarchy.get(parent);
+      
       if (subClasses == null)
       {
          return Collections.emptyList();

=== modified file 'src/com/goldencode/p2j/convert/db/ConversionData.java'
--- old/src/com/goldencode/p2j/convert/db/ConversionData.java	2021-10-12 08:35:45 +0000
+++ new/src/com/goldencode/p2j/convert/db/ConversionData.java	2022-05-12 15:03:49 +0000
@@ -2,7 +2,7 @@
 ** Module   : ConversionData.java
 ** Abstract : Main access to incremental conversion db-backed data.
 **
-** Copyright (c) 2020-2021, Golden Code Development Corporation.
+** Copyright (c) 2020-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------Description----------------------------------
 ** 001 CA  20200412 Created initial version, for incremental conversion support.
@@ -14,7 +14,9 @@
 **                  keys must be considered as dependencies and their files reconverted, too.
 **     CA  20211012 Fixed generated WSDL and reworked SOAP support to rely on namespace, when resolving an
 **                  operation.
+**     GES 20220502 Match API method name change.
 */
+
 /*
 ** This program is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU Affero General Public License as
@@ -701,7 +703,7 @@
       String filename = clsDef.getFilename();
       String qname = clsDef.getName();
       String jpkgname = clsDef.getJavaPackage();
-      String jclassname = clsDef.getJavaSimpleName();
+      String jclassname = clsDef.getSimpleJavaName();
       
       String insertSql = "MERGE INTO class_definitions KEY (filename) values (?, ?, ?, ?, ?, ?, ?)";
       helper.executeSQL(insertSql, 

=== modified file 'src/com/goldencode/p2j/oo/core/collections/AbstractTtcollection.java'
--- old/src/com/goldencode/p2j/oo/core/collections/AbstractTtcollection.java	2022-05-13 06:58:53 +0000
+++ new/src/com/goldencode/p2j/oo/core/collections/AbstractTtcollection.java	2022-05-20 12:11:18 +0000
@@ -9,13 +9,13 @@
 ** 002 CA  20210113 Renamed Iiterator.next to Iiterator.next_, to follow NameConverter's rules.
 **         20210113 Renamed clear() to clear_(), to follow NameConverter's rules.
 ** 003 ME  20210128 Keep only the default 4GL temp-table implementation.
-** 004 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
-**                  signature.
+** 004 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy signature.
 **     CA  20210609 Updated INPUT/INPUT-OUTPUT parameters to the new approach, where they are explicitly 
 **                  initialized at the method's execution, and not at the caller's arguments.
 **     ME  20210928 Fix return value on clone method, defined out of the function block.
 **     CA  20220513 Renamed _BaseObject_.clone() to legacyClone(), as it can be overriden by sub-classes and
 **                  the access mode may collide with the Java's Object.clone().
+**     GES 20220520 Upgraded table-handle parameter processing to match API changes.
 */
 
 /*
@@ -70,6 +70,7 @@
 **     Corporation or FWD.  All modified versions must contain the notices of
 **     attribution required in this license.
 */
+
 package com.goldencode.p2j.oo.core.collections;
 
 import com.goldencode.p2j.util.*;
@@ -249,7 +250,7 @@
          if (getLegacyClass().ref()
                   .legacyEquals(p1.ref().getLegacyClass()).booleanValue())
          {
-            p1.ref().toTable(new TableParameter(tableHandle, true));
+            p1.ref().toTable(new OutputTableHandle(tableHandle, ParameterOption.APPEND));
             size.assign(size.intValue() + p1.ref().getSize().intValue());
          }
          else
@@ -342,13 +343,13 @@
    @LegacySignature(type = Type.METHOD, name = "ToTable", parameters = {
             @LegacyParameter(name = "p1", type = "HANDLE", mode = "OUTPUT") })
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
-   public void toTable(final TableParameter _p1)
+   public void toTable(final OutputTableHandle _p1)
    {
       handle p1 = new handle();
 
       internalProcedure(AbstractTtcollection.class, this, "ToTable", new Block((Body) () ->
       {
-         TemporaryBuffer.createDynamicTable(_p1, p1, false, true);
+         TemporaryBuffer.createDynamicTable(_p1, p1);
          p1.assign(tableHandle);
       }));
    }

=== modified file 'src/com/goldencode/p2j/oo/core/collections/Array.java'
--- old/src/com/goldencode/p2j/oo/core/collections/Array.java	2022-05-13 06:58:53 +0000
+++ new/src/com/goldencode/p2j/oo/core/collections/Array.java	2022-05-20 12:11:07 +0000
@@ -12,13 +12,13 @@
 ** 004 ME  20200529 Complete to match the 4GL implementation.
 ** 005 CA  20210113 Renamed Iiterator.next to Iiterator.next_, to follow NameConverter's rules.
 **         20210113 Renamed clear() to clear_(), to follow NameConverter's rules.
-** 006 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
-**                  signature.
+** 006 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy signature.
 **     ME  20210916 Fix wrong method call on set (increment instead of decrement). Clean-up resize
 **                  and fix 'retainAll' method.
 **     ME  20210929 Fix clone return value.
 **     CA  20220513 Renamed _BaseObject_.clone() to legacyClone(), as it can be overriden by sub-classes and
 **                  the access mode may collide with the Java's Object.clone().
+**     GES 20220520 Upgraded table-handle parameter processing to match API changes.
 */
 
 /*
@@ -621,15 +621,16 @@
    }
 
    @LegacySignature(type = Type.METHOD, name = "ToTable", parameters = {
-            @LegacyParameter(name = "p1", type = "HANDLE", mode = "INPUT") })
+            @LegacyParameter(name = "p1", type = "HANDLE", mode = "OUTPUT") })
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_STUB)
-   public void toTable(final TableParameter _p1)
+   public void toTable(final OutputTableHandle _p1)
    {
       handle p1 = new handle();
 
       // TODO: convert array to temp table
-      internalProcedure(this, "ToTable", new Block((Init) () -> {
-         TemporaryBuffer.createDynamicTable(_p1, p1, false, false);
+      internalProcedure(this, "ToTable", new Block((Init) () ->
+      {
+         TemporaryBuffer.createDynamicTable(_p1, p1);
       }));
    }
 }

=== modified file 'src/com/goldencode/p2j/oo/core/collections/Icollection.java'
--- old/src/com/goldencode/p2j/oo/core/collections/Icollection.java	2021-02-21 16:25:50 +0000
+++ new/src/com/goldencode/p2j/oo/core/collections/Icollection.java	2022-05-12 15:03:49 +0000
@@ -10,8 +10,8 @@
 ** 002 CA  20191024 Added method support levels and updated the class support level.
 ** 003 ME  20200729 Update parameter names to match skeleton.
 ** 004 CA  20210113 Renamed clear() to clear_(), to follow NameConverter's rules.
-** 005 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
-**                  signature.
+** 005 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy signature.
+**     GES 20210501 Upgraded table-handle parameter processing to match API changes.
 */
 
 /*
@@ -157,8 +157,8 @@
 
    @LegacySignature(type = Type.METHOD, name = "ToTable", parameters = 
    {
-      @LegacyParameter(name = "p1", type = "HANDLE", mode = "INPUT")
+      @LegacyParameter(name = "p1", type = "HANDLE", mode = "OUTPUT")
    })
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL|RT_LVL_FULL)
-   public void toTable(final TableParameter _p1);
+   public void toTable(final OutputTableHandle _p1);
 }

=== modified file 'src/com/goldencode/p2j/oo/core/collections/Ilist.java'
--- old/src/com/goldencode/p2j/oo/core/collections/Ilist.java	2021-02-21 16:25:50 +0000
+++ new/src/com/goldencode/p2j/oo/core/collections/Ilist.java	2022-05-12 15:03:49 +0000
@@ -2,13 +2,13 @@
 ** Module   : IList.java
 ** Abstract : Implementation of the builtin class.
 **
-** Copyright (c) 2019-2021, Golden Code Development Corporation.
+** Copyright (c) 2019-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------------Description----------------------------------------
 ** 001 ME  20200729 Convert from skeleton (OE12.2).
 ** 002 CA  20210113 Renamed clear() to clear_(), to follow NameConverter's rules.
-** 003 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
-**                  signature.
+** 003 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy signature.
+** 004 GES 20220511 Upgraded table-handle parameter processing to match API changes.
 */
 
 /*
@@ -209,7 +209,7 @@
    {
       @LegacyParameter(name = "p1", type = "HANDLE", mode = "OUTPUT")
    })
-   public void toTable(final TableParameter _p1);
+   public void toTable(final OutputTableHandle _p1);
 
    @LegacySignature(returns = "OBJECT", type = Type.METHOD, name = "ToArray", extent = -1, qualified = "progress.lang.object")
    public object<? extends com.goldencode.p2j.oo.lang._BaseObject_>[] toArray();

=== modified file 'src/com/goldencode/p2j/oo/core/collections/LegacyCollection.java'
--- old/src/com/goldencode/p2j/oo/core/collections/LegacyCollection.java	2022-01-20 16:27:48 +0000
+++ new/src/com/goldencode/p2j/oo/core/collections/LegacyCollection.java	2022-05-12 15:03:49 +0000
@@ -4,17 +4,18 @@
 **
 ** Copyright (c) 2019-2022, Golden Code Development Corporation.
 **
-** -#- -I- --Date-- ---------------------------------------Description----------------------------------------
+** -#- -I- --Date-- --------------------------------------Description---------------------------------------
 ** 001 ME  20200519 First version, stubs taken by converting the skeleton using FWD.
 ** 002 ME  20210128 Implement this using a Java collection, simply override all from AbstratTTCollection.
 ** 003 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy signature.
-** 004 ME  20210325 Decrement object reference when removed from collection.
+**     ME  20210325 Decrement object reference when removed from collection.
 **     CA  20210609 Updated INPUT/INPUT-OUTPUT parameters to the new approach, where they are explicitly 
 **                  initialized at the method's execution, and not at the caller's arguments.
 **     CA  20220120 Do not used TypeFactory.object when the OO reference must not be tracked or registered.
 **                  Do not use TypeFactory.object for internal usages, use ObjectVar if the reference must 
 **                  be tracked.
 **                  All TypeFactory.object variable definitions must be done outside of the top-level block.
+**     GES 20210501 Upgraded table-handle parameter processing to match API changes.
 */
 
 /*
@@ -69,6 +70,7 @@
 **     Corporation or FWD.  All modified versions must contain the notices of
 **     attribution required in this license.
 */
+
 package com.goldencode.p2j.oo.core.collections;
 
 import com.goldencode.p2j.util.*;
@@ -323,14 +325,14 @@
             @LegacyParameter(name = "p1", type = "HANDLE", mode = "OUTPUT") })
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_STUB)
    @Override
-   public void toTable(final TableParameter _p1)
+   public void toTable(final OutputTableHandle _p1)
    {
       handle p1 = new handle();
 
       internalProcedure(AbstractTtcollection.class, this, "ToTable", new Block((Body) () ->
       {
          // TODO: create table from collection
-         TemporaryBuffer.createDynamicTable(_p1, p1, false, true);
+         TemporaryBuffer.createDynamicTable(_p1, p1);
       }));
    }
 

=== modified file 'src/com/goldencode/p2j/oo/core/collections/MapBackedCollection.java'
--- old/src/com/goldencode/p2j/oo/core/collections/MapBackedCollection.java	2021-06-09 14:35:48 +0000
+++ new/src/com/goldencode/p2j/oo/core/collections/MapBackedCollection.java	2022-05-12 15:03:49 +0000
@@ -8,10 +8,10 @@
 ** 001 ME  20200514 First version, stubs taken by converting the skeleton using FWD.
 ** 002 CA  20210113 Renamed Iiterator.next to Iiterator.next_, to follow NameConverter's rules.
 **                  Renamed clear() to clear_(), to follow NameConverter's rules.
-** 003 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
-**                  signature.
+** 003 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy signature.
 **     CA  20210609 Updated INPUT/INPUT-OUTPUT parameters to the new approach, where they are explicitly 
 **                  initialized at the method's execution, and not at the caller's arguments.
+**     GES 20210501 Upgraded table-handle parameter processing to match API changes.
 */
 
 /*
@@ -93,7 +93,9 @@
  */
 @LegacyResource(resource = "OpenEdge.Core.Collections.MapBackedCollection")
 @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_PARTIAL)
-public abstract class MapBackedCollection extends BaseObject implements Icollection
+public abstract class MapBackedCollection
+extends BaseObject
+implements Icollection
 {
    @LegacySignature(type = Type.PROPERTY, name = "OwningMap")
    private object<? extends Imap> owningMap = TypeFactory.object(Imap.class);
@@ -339,7 +341,7 @@
    @LegacySignature(type = Type.METHOD, name = "ToTable", parameters = {
             @LegacyParameter(name = "p1", type = "HANDLE", mode = "OUTPUT") })
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_PARTIAL)
-   public void toTable(final TableParameter _p1)
+   public void toTable(final OutputTableHandle _p1)
    {
       handle p1 = new handle();
 
@@ -347,7 +349,7 @@
       {
          if (objectsMap != Collections.EMPTY_MAP)
          {
-            TemporaryBuffer.createDynamicTable(_p1, p1, false, true);
+            TemporaryBuffer.createDynamicTable(_p1, p1);
             p1.assign(owningBuffer);
          }
          // TODO: add object to temp-table if java map is used

=== modified file 'src/com/goldencode/p2j/oo/lang/ParameterList.java'
--- old/src/com/goldencode/p2j/oo/lang/ParameterList.java	2021-05-10 06:17:30 +0000
+++ new/src/com/goldencode/p2j/oo/lang/ParameterList.java	2022-05-12 15:03:49 +0000
@@ -2,7 +2,7 @@
 ** Module   : ParameterList.java
 ** Abstract : Implementation of the Progress.Lang.ParameterList builtin class.
 **
-** Copyright (c) 2018-2021, Golden Code Development Corporation.
+** Copyright (c) 2018-2022, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- ---------------------------------------Description----------------------------------------
 ** 001 CA  20181213 First version.
@@ -10,11 +10,11 @@
 ** 003 CA  20190527 Added annotations for property accessors and class event methods.
 ** 005 CA  20190720 Emit the 'this' reference for the BlockManager APIs.
 ** 006 CA  20191024 Added method support levels and updated the class support level.
-** 003 CA  20210113 Renamed clear() to clear_(), to follow NameConverter's rules.
+** 007 CA  20210113 Renamed clear() to clear_(), to follow NameConverter's rules.
 **     CA  20210216 Methods which have an int parameter must use the BlockManager API for top-level block.
-** 004 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
-**                  signature.
-** 005 ME  20210507 Improve parameter validation (call syntax uses '-' as separator instead space).
+** 008 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy signature.
+** 009 ME  20210507 Improve parameter validation (call syntax uses '-' as separator instead space).
+** 010 GES 20220511 Match changes in CallMode and ParameterOption.
 */
 
 /*
@@ -295,13 +295,10 @@
                if (cmode.inputOutput)
                   return false;
             case BY_REFERENCE:
-               if (cmode.append)
-                  return false;
                needDataStructure = true;
-
          }
          
-         needDataStructure = needDataStructure || cmode.append;
+         needDataStructure = needDataStructure || cmode.mode == ParameterOption.APPEND;
              
          if (needDataStructure)
             return ("TABLE".equalsIgnoreCase(type) || "TABLE-HANDLE".equalsIgnoreCase(type)

=== modified file 'src/com/goldencode/p2j/pattern/CommonAstSupport.java'
--- old/src/com/goldencode/p2j/pattern/CommonAstSupport.java	2022-03-07 07:56:55 +0000
+++ new/src/com/goldencode/p2j/pattern/CommonAstSupport.java	2022-05-12 15:03:49 +0000
@@ -2,9 +2,9 @@
 ** Module   : CommonAstSupport.java
 ** Abstract : Common symbol resolution and function support for AST processing
 **
-** Copyright (c) 2005-2021, Golden Code Development Corporation.
+** Copyright (c) 2005-2022, Golden Code Development Corporation.
 **
-** -#- -I- --Date-- --JPRM-- ----------------------------Description-----------------------------
+** -#- -I- --Date-- --JPRM-- ---------------------------------Description----------------------------------
 ** 001 ECF 20050228   @20100 Created initial version. Exposes basic AST
 **                           properties and provides AST-related actions,
 **                           including editing and annotation processing.
@@ -273,6 +273,9 @@
 **                           multi-context mode, as the pattern workers are singletons.
 **     HC  20211215          Added support for implicit OCX arguments.
 **     ME  20211025          Added AST node as input to loadConvertedClass method.
+**     GES 20220427          Modified to match code refactoring for OO method matching. Rework to eliminate
+**                           ConvertedClassName. Instead the ClassDefinition handles all converted name
+**                           processing.
 */
 
 /*
@@ -584,7 +587,7 @@
                      LegacySignature ls = mthd.getAnnotation(LegacySignature.class);
                      if (ls != null)
                      {
-                        String lsig = ClassDefinition.computeLegacySignature(ls.name(), ls);
+                        String lsig = SymbolResolver.calculateLegacySignature(ls.name(), ls);
                         if (lsig != null && lsig.equalsIgnoreCase(signature))
                         {
                            LegacyResourceSupport lrs = mthd.getAnnotation(LegacyResourceSupport.class);
@@ -612,9 +615,9 @@
       }
       
       /**
-       * Load the specified converted class.  This will either create a {@link ClassDefinition}
-       * structure for a new class (to be later populated with members by the parser), or will 
-       * restore an instance from an already-converted class.
+       * Load the specified class definition.  This will either create a {@link ClassDefinition}
+       * structure for a new class (to be later populated with members by the parser), or will restore
+       * an instance from an already-converted class.
        * 
        * @param    filename
        *           The file name for the legacy OO class.
@@ -624,22 +627,24 @@
        * @param    ast 
        *           The abstract syntax tree node.
        *           
-       * @return   See above.
+       * @return   The class definition.
        * 
        * @throws   ClassNotFoundException
        *           If the class can't be resolved or loaded.
        */
-      public ConvertedClassName loadConvertedClass(String filename, boolean isNew, Aast ast)
-               throws ClassNotFoundException
+      public ClassDefinition loadConvertedClass(String filename, boolean isNew, Aast ast)
+      throws ClassNotFoundException
       {
          if (filename == null)
-            throw new ClassNotFoundException(
-                     "Can not find class for accessing " + ast.toStringVerbose());
+         {
+            throw new ClassNotFoundException("Can not find class for accessing " + ast.toStringVerbose());
+         }
+         
          return SymbolResolver.loadConvertedClass(filename, isNew);
       }
       
       /**
-       * Load the specified converted class.  This lookup an instance from an already-converted class.
+       * Load the specified class definition.
        * 
        * @param    qname
        *           The legacy OO class qualified name.
@@ -649,7 +654,7 @@
        * @throws   ClassNotFoundException
        *           If the class can't be resolved or loaded.
        */
-      public ConvertedClassName loadConvertedClassByQname(String qname)
+      public ClassDefinition loadConvertedClassByQname(String qname)
       throws ClassNotFoundException
       {
          return SymbolResolver.loadConvertedClassByQname(qname);
@@ -5763,9 +5768,8 @@
                                         String pkgname, 
                                         String classname)
       {
-         String ooname = (pkgname.isEmpty() ? "" : pkgname + ".") + classname;
          ClassDefinition cls = SymbolResolver.getClassDefinition(legacyName);
-         cls.setJavaClassName(ooname);
+         cls.setJavaClassName(pkgname, classname);
          
          ConversionData.setConvertedClassName(filename, pkgname, classname);
       }

